"use strict";

var config;
var db;

function init(options) {
    config = options.config;
    db = options.db;
}

function _getByMessageid(messageid, cb) {
    let dbConnection = db.connection();
    if (!dbConnection) {
        cb("db is not connected");
        return;
    }

    let query = "SELECT * FROM T_TRANS WHERE 1=1";
    let filter = {"MESSAGEID": messageid};

    let queryWithFilter = db.composeQueryWithFilter(query, filter);

    dbConnection.execute(queryWithFilter.query, queryWithFilter.values, function(err, res) {
        if (err) {
            cb(err, null);
            return;
        }

        let retval = db.createResultObject(res);

        if (retval && retval.length > 0) {
            cb(null, retval[0]);
        }
        else {
            cb(null, null);
        }
    });
}

function getByMessageid(req, res, next) {
    _getByMessageid(req.params.messageid, function(err, result) {
        if (err) {
            res.send(err.message);
            return;
        }

        res.send(result);
    });
}

exports.init = init;
exports.getByMessageid = getByMessageid
